.nolist
COMMENT @ inspired by http://www.masm32.com/board/index.php?topic=6181.15

InstrCi knows three search modes, passed with the fourth para:

StartPos equ 1

1.	invoke InstrCi, StartPos, addr Mainstr, addr SubstrxCi, 0
	start at pos 1, search case-sensitive for SubstrxCi in Mainstr

2.	invoke InstrCi, StartPos, addr Mainstr, addr SubstrxCi, 1
	start at pos 1, search case-insensitive for SubstrxCi in Mainstr

3.	invoke InstrCi, StartPos, addr Mainstr, addr SubstrxCi, 2
	start at pos 1, search for SubstrxCi in Mainstr, ignore case of first character

The first para indicates the start position. Use 1 for a standard search.
If this para is 0, then InstrCi continues directly after the last match.

You may use the FindString macro as follows:
FindString addr MainString, addr SubString [, sMode] [, sPos]
FindString addr MainString, addr SubString			; case-sensitive search starting at pos 1
FindString addr MainString, addr SubString, 1	; case-insensitive, default start at pos 1
FindString addr MainString, addr SubString, 0, 0	; case-sensitive, start at last match
FindString addr MainString, addr SubString, 2, 99	; first char case-insensitive, start pos 99
etc. @

    .686
    .MODEL FLAT,STDCALL
    OPTION CASEMAP:NONE
  
    include \masm32\include\windows.inc
    include \masm32\macros\timers.asm      
    include \masm32\macros\macros.asm    
    include \masm32\include\kernel32.inc
    include \masm32\include\masm32.inc
    include \masm32\include\user32.inc
    include \masm32\include\msvcrt.inc
    include \masm32\include\shlwapi.inc

    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\msvcrt.lib
    includelib \masm32\lib\shlwapi.lib

    InStringL	PROTO :DWORD, :DWORD
    InstrCi	PROTO :DWORD, :DWORD, :DWORD, :DWORD
    finstr	PROTO :DWORD, :DWORD, :DWORD
    BM	PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

FindString MACRO pMain:REQ, pSub:REQ, sMode:=<0>, sPos:=<1>
  invoke InstrCi, sPos, pMain, pSub, sMode
ENDM

; 

.data
Mainstr	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot "
	db "and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot "
	db "and whether pigs have wings and fly like elephants in the sky...", 0

Substrx	db "wings", 0	; for the first three algos, crt_strstr, finstr and InStringL
SubstrxCi	db "Wings", 0
SubstrxCiL	db "Wings and fly like elephants in the sky", 0

; this yields a correct result (pos 2616) for the BM algo:
BM_long	db "ve wings and fly like elephants in the sky", 0
; BM_longOk	db "ve wi", 0

; these variants yields wrong results for the Boyer-Moore algo:
BM_longWR1	db "ave wings and fly like elephants in the sky", 0
BM_longWR2	db "ave wi", 0

cl1	dd 0
cl2	dd 0
cl3	dd 0
cl4s1	dd 0	; short pattern, mode 1 = case insensitive
cl4s2	dd 0	; short pattern, mode 2 = first char case insensitive
cl4l1	dd 0	; long pattern, mode 1 = case insensitive
cl4l2	dd 0	; long pattern, mode 2 = first char case insensitive
cl4t	dd 0
cl4t1	dd 0
cl4t2	dd 0
cl5	dd 0
cl6s	dd 0
cl6l	dd 0
cl7	dd 0

.data?
res1	dd ?
res2	dd ?
res3	dd ?
res4s1	dd ?
res4s2	dd ?
res4l1	dd ?
res4l2	dd ?
res5	dd ?
res6s	dd ?
res6l	dd ?
res7	dd ?
CurPos	dd ?
plenS	dd ?
plenL	dd ?
slen	dd ?

.code
start:

; 

    mov slen, len(OFFSET Mainstr)
    mov plenS, len(OFFSET Substrx)
    mov plenL, len(OFFSET Substrx)

NumLoops EQU 10000

  REPEAT 8

    LOOP_COUNT EQU NumLoops 
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke crt_strstr,addr Mainstr,addr Substrx
    mov res1, eax
    counter_end
    add cl1, eax
    print str$(eax)," timing crt_strstr",13,10

    LOOP_COUNT EQU NumLoops 
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke finstr,0,addr Mainstr,addr Substrx
    mov res2, eax
    counter_end
    add cl2, eax
    print str$(eax)," timing finstr",13,10

    LOOP_COUNT EQU NumLoops 
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke InStringL,addr Mainstr,addr Substrx
    mov res3, eax
    counter_end
    add cl3, eax
    print str$(eax)," timing InStringL",13,10

    LOOP_COUNT EQU NumLoops 
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    ; FindString addr Mainstr, addr SubstrxCi, 1, 1	; same as macro, mode+spos optional
    invoke InstrCi, 1, addr Mainstr, addr SubstrxCi, 1	; 1=case-insensitive
    mov res4s1, eax
    counter_end
    add cl4s1, eax
    print str$(eax)," timing InstrCi 1s",13,10

    LOOP_COUNT EQU NumLoops 
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    ; FindString addr Mainstr, addr SubstrxCi, 2, 1	; same as macro, mode+spos optional
    invoke InstrCi, 1, addr Mainstr, addr SubstrxCi, 2	; 2=intelligent ci
    mov res4s2, eax
    counter_end
    add cl4s2, eax
    print str$(eax)," timing InstrCi 2s",13,10

    LOOP_COUNT EQU NumLoops 
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke InstrCi, 1, addr Mainstr, addr SubstrxCiL, 1	; 1=case-insensitive, 2=intelligent ci, LONG pattern
    mov res4l1, eax
    counter_end
    add cl4l1, eax
    print str$(eax)," timing InstrCi 1L",13,10

    LOOP_COUNT EQU NumLoops 
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke InstrCi, 1, addr Mainstr, addr SubstrxCiL, 2	; 1=case-insensitive, 2=intelligent ci, LONG pattern
    mov res4l2, eax
    counter_end
    add cl4l2, eax
    print str$(eax)," timing InstrCi 2L",13,10

    LOOP_COUNT EQU NumLoops
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke BM,0,ADDR Mainstr,slen,ADDR Substrx,plenS
    mov res6s, eax
    counter_end
    add cl6s, eax
    print str$(eax)," timing Boyer-Moore short", 13,10

    LOOP_COUNT EQU NumLoops
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke BM,0,ADDR Mainstr,slen,ADDR BM_long, plenL
    mov res6l, eax
    counter_end
    add cl6l, eax
    print str$(eax)," timing Boyer-Moore long", 13,10

    LOOP_COUNT EQU NumLoops
    counter_begin LOOP_COUNT/100, HIGH_PRIORITY_CLASS
    mov res7, istring(1, addr Mainstr, addr Substrx)
    counter_end
    add cl7, eax
    print str$(eax)," timing HLL istring", 13,10

    LOOP_COUNT EQU NumLoops
    counter_begin LOOP_COUNT/100, HIGH_PRIORITY_CLASS
    invoke StrStrI, addr Mainstr, addr SubstrxCi
    mov res5, eax
    counter_end
    add cl5, eax
    print str$(eax)," timing StrStrI (shlwapi.dll)", 13,10, 13,10
 
  ENDM

    shr cl1, 3
    shr cl2, 3
    shr cl3, 3
    shr cl4s1, 3
    shr cl4s2, 3
    shr cl4l1, 3
    shr cl4l2, 3
	mov eax, cl4s1
	add eax, cl4l1
	shr eax, 1
	mov cl4t1, eax	; mode 1 avg
	mov ecx, cl4s2
	add ecx, cl4l2
	shr ecx, 1
	mov cl4t2, ecx	; mode 2 avg
	add eax, ecx
	shr eax, 1
	mov cl4t, eax	; InstrCi avg
    shr cl5, 3
    shr cl6s, 3
    shr cl6l, 3
    shr cl7, 3

    print "----------------------",13,10
    print str$(cl1)," average crt_strstr",9, "res="
    print str$(res1),13,10
    print str$(cl2)," average finstr    ",9, "res="
    print str$(res2),13,10
    print str$(cl3)," average InStringL  ",9, "res="
    print str$(res3),13,10
    print str$(cl4s1)," average InstrCi 1s",9, "res="
    print str$(res4s1),13,10
    print str$(cl4s2)," average InstrCi 2s",9, "res="
    print str$(res4s2),13,10
    print str$(cl4l1)," average InstrCi 1L",9, "res="
    print str$(res4l1),13,10
    print str$(cl4l2)," average InstrCi 2L",9, "res="
    print str$(res4l2),13,10
;    print str$(cl4t1)," mode 1 avg InstrCi",13,10
;    print str$(cl4t2)," mode 2 avg InstrCi",13,10
;	mov eax, cl4t1
;	sub eax, cl4t2
;    print str$(eax)," diff modes InstrCi",13,10
    print str$(cl4t)," * average InstrCi",13,10
	mov eax, cl2
	sub eax, cl4t
    print str$(eax)," diff finstr-InstrCi (neg = finstr is faster)",13,10
	mov eax, cl6s
	sub eax, cl4t
    print str$(eax)," diff BM s - InstrCi (neg = BM is faster)",13,10
    print str$(cl6s)," avg Boyer-Moore s",9, "res="
    print str$(res6s),13,10
    print str$(cl6l)," avg Boyer-Moore L",9, "res="
    print str$(res6l),13,10
    print str$(cl7)," Hll istring",9, "res="
    print str$(res7),13,10
    print str$(cl5)," average StrStrI",9, "res="
    print str$(res5),13,10,13,10, "Sizes:",13,10

	lea ecx, Retfinstr
	lea eax, finstr
	sub ecx, eax
	print str$(ecx)," finstr", 13, 10

	lea ecx, RetInStringL
	lea eax, InStringL
	sub ecx, eax
	print str$(ecx)," InStringL", 13, 10

	lea ecx, RetInstrCi
	lea eax, InstrCi
	sub ecx, eax
	print str$(ecx)," InstrCi", 13, 10

	lea ecx, RetBM
	lea eax, BM
	sub ecx, eax
	print str$(ecx)," Boyer-Moore", 13, 10

    print "----------------------",13,10

    inkey

invoke ExitProcess, 0

; 
OPTION PROLOGUE:NONE			; turn it off
OPTION EPILOGUE:NONE			;
align 16						;
InStringL	proc lpSource:DWORD, lpPattern:DWORD
	mov		eax, [esp+1*4]		; eax-> lpSource
    mov		edx, [esp+2*4]		; edx->lpPattern
    movzx	ecx, byte ptr [edx] ; ecx->the 1st byte of substring
	mov		[esp+2*4], esi		; saving register esi
    imul	ecx, 1010101h       ; ecx=77 77 77 77h  ; 77h -> ASCII code of "w"
	mov		[esp+1*4], ebx		; saving register ebx
	lea		esi, [edx+1]		; esi->lp Pattern +1
BytesScan:						;
	mov		edx, ecx			; edx=77 77 77 77h  ; 77h -> ASCII code of "w"
	xor		ebx, ebx			;
@@:								;
	xor		ecx, [eax]			;
	add		eax, 4				;              
	add		ecx, 0FEFEFEFFh		;   
    test	ecx, 080808080h		;   
	mov		ecx, edx			; edx=77 77 77 77h  ; 77h -> ASCII code of "w"
  	je		@b					; 
								;
    cmp		[eax-4], dl			; dl ->1st byte of pattern
    lea		eax, [eax-3]	
	je		@f
    cmp		[eax], dl			; dl ->1st byte of pattern
    lea		eax, [eax+1]	
	je		@f
    cmp		[eax], dl			; dl ->1st byte of pattern
    lea		eax, [eax+1]
	je		@f
    cmp		[eax], dl			; dl ->1st byte of pattern
    lea		eax, [eax+1]
	jne		@b
@@:								; CMP rest  of strings
	add		bl,	 [esi]
	je		@found	
	sub		bl,	 [eax]
	jne		BytesScan
	add		bl,	 [esi+1]
	je		@found	
	sub		bl,	 [eax+1]
	jne		BytesScan
	add		bl,	 [esi+2]
	je		@found	
	sub		bl,	 [eax+2]
	jne		BytesScan
	add		bl,	 [esi+3]
	je		@found	
	sub		bl,	 [eax+3]
	jne		BytesScan	
	add		bl,	 [esi+4]
	je		@found	
	sub		bl,	 [eax+4]
	jne		BytesScan
	add		bl,	 [esi+5]
	je		@found	
	sub		bl,	 [eax+5]
	jne		BytesScan
	add		bl,	 [esi+6]
	je		@found	
	sub		bl,	 [eax+6]
	jne		BytesScan
	add		bl,	 [esi+7]
	je		@found	
	sub		bl,	 [eax+7]
	jne		BytesScan
	add		bl,	 [esi+8]
	je		@found	
	sub		bl,	 [eax+8]
	jne		BytesScan
	mov		edx, 8
@@:	
	add		bl,	 [esi+edx+1]
	je		@found	
	sub		bl,	 [eax+edx+1]
	jne		BytesScan
	add		bl,	 [esi+edx+2]
	je		@found	
	sub		bl,	 [eax+edx+2]
	jne		BytesScan
	add		bl,	 [esi+edx+3]
	je		@found	
	sub		bl,	 [eax+edx+3]
	jne		BytesScan
	add		bl,	 [esi+edx+4]
	je		@found	
	sub		bl,	 [eax+edx+4]
	jne		BytesScan
	add		edx, 4
	jne		@b
@found:	
	mov		ebx, [esp+1*4]	 
	cmp		eax, esi		
	mov		esi, [esp+2*4]	 
	sbb		ecx, ecx
	mov		edx, [esp]	 
	add		eax,  -1		
	add		esp, 3*4 
	and		eax, ecx		;eax-> address of 1st occurrence or 0->Not found   
	jmp		edx
InStringL	endp
RetInStringL:

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

align 16

finstr proc spos:DWORD,psrc:DWORD,patn:DWORD

    .data?
      align 16
      _ebx dd ?
      _esi dd ?
      _edi dd ?
      _ebp dd ?
    .code

    mov _ebx, ebx
    mov _esi, esi
    mov _edi, edi
    mov _ebp, ebp

    mov ebp, 1
    mov edi, [esp+12]               ; patn
    movzx eax, BYTE PTR [edi]       ; set 1st patn byte in AL
    mov esi, [esp+8]                ; psrc
    add esi, [esp+4]                ; spos
    sub esi, ebp

; --------------------

  align 16
  scanloop:
  REPEAT 15
    add esi, ebp
    movzx edx, BYTE PTR [esi]
    cmp eax, edx
    je prematch
    test edx, edx                   ; test for source terminator
    jz no_match
  ENDM

    add esi, ebp
    movzx edx, BYTE PTR [esi]
    cmp eax, edx
    je prematch
    test edx, edx                   ; test for source terminator
    jnz scanloop
    jmp no_match

; --------------------

  align 16
  prematch:
    xor ebx, ebx

; --------------------

  matchloop:
  REPEAT 7
    add ebx, ebp
    movzx ecx, BYTE PTR [esi+ebx]
    movzx edx, BYTE PTR [edi+ebx]
    test edx, edx                   ; test for patn terminator
    jz match
    cmp ecx, edx
    jne scanloop
  ENDM

    add ebx, ebp
    movzx ecx, BYTE PTR [esi+ebx]
    movzx edx, BYTE PTR [edi+ebx]
    test edx, edx                   ; test for patn terminator
    jz match
    cmp ecx, edx
    jne scanloop
    jmp matchloop

; --------------------

  match:
    sub esi, [esp+8]                ; psrc
    mov eax, esi
    jmp cleanup

  no_match:
    xor eax, eax

  cleanup:
    mov ebx, _ebx
    mov esi, _esi
    mov edi, _edi
    mov ebp, _ebp

    ret 12

finstr endp
Retfinstr:

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; ##############################################
align 16

InstrCi proc uses edi esi ebx StartPos:DWORD, lpSource:DWORD, lpPattern:DWORD, sMode:DWORD
  mov eax, lpSource		; e.g. invoke InstrCi, 1, addr Mainstr, addr SubstrxCi, 0 means
  mov ecx, StartPos		; start at pos1, find Substr in Mainstr, case-sensitive
  .if ecx
	dec ecx				; 1-based index, so if 1 is passed, please add nothing to eax
  .else
	mov ecx, CurPos	; invoke InstrCi, 0, ... means continue with Current Position
  .endif
  add eax, ecx				; start with current position or StartPos
  xor ebx, ebx				; default mode: case-sensitive search
  .if sMode
	add ebx, 20h		; intellicase: finds "test" and "Test" but not "TEST" in "This is a Test"
	.if sMode==1		; lowercase bit mask for finding "TEST" in "This is a Test"
		mov ebx, 20202020h
	.endif
  .endif

NoSucc:
  mov edx, lpPattern	; address of pattern
  mov edx, [edx]		; edx has 4 bytes of pattern, e.g. test
  or edx, ebx			; make first byte or first 4 bytes of pattern lowercase, if sMode is set

@@:
	REPEAT 3
	movzx ecx, word ptr [eax]	; take a word from the source string
	test cl, cl		; source end?
	jz SrcEnd
	or ecx, ebx		; make source lowercase
	add eax, 1		; these 3 are innermost loops, and inc eax would cost 2-3%
	cmp cx, dx		; compare 2 bytes of source with pattern
	je @F
	ENDM

	movzx ecx, word ptr [eax]	; take a word from the source string
	test cl, cl		; source end?
	jz SrcEnd
	or ecx, ebx		; make source lowercase
	add eax, 1		; this is the last innermost loop, and inc eax would cost 2-3%
	cmp cx, dx		; compare 2 bytes of source with pattern
	jne @B

@@:	mov esi, lpPattern
	mov edi, eax	; current pos in source string
	inc esi			; inc changes flags
	push eax		; save current pos

@@:	mov al, [esi]	; movzx eax, byte ptr [esi]
	inc esi			; add esi, 1 is faster but here it doesn't matter
	test al, al		; pattern end?
	jz @F
	or al, bh		; make lowercase; mode 0,2: bh=0, mode 1: bh=20h
	mov cl, [edi]
	or cl, bh			; make lowercase; mode 0,2: bh=0, mode 1: bh=20h
	inc edi			; add edi, 1 is faster but here it doesn't matter
	cmp al, cl		; if equal, go for the next char
	je @B

@@:	pop eax		; current pos in source string restored

	mov ecx, [esi-1]	; check for end of pattern - if yes, we are done
	or cl, cl			; get the flag
	jz @F			; if not zero, we still have to test a...
	mov ecx, [esi-2]		; ... rare case: pattern and source finish on the same byte
	or cl, cl
	jnz NoSucc

@@:	mov ecx, eax		; SUCCESS!
	sub ecx, lpSource	; ecx has the relative pos, if needed
	mov CurPos, ecx	
	dec eax				; we return in eax the pos in lpSource where the pattern was found
	jmp @F

SrcEnd:
	xor eax, eax		; no match found, sorry
@@:
	ret
InstrCi endp
RetInstrCi:

; ##############################################

align 16

BM proc startpos:DWORD,lpSource:DWORD,srcLngth:DWORD,
                       lpSubStr:DWORD,subLngth:DWORD

  ; -----------------------------------------------------------------
  ; This version uses four heuristics, it determines the shift type
  ; from the character in the table, if the character is not in the
  ; pattern, it performs a BAD CHARACTER shift, if the character is
  ; in the pattern, it determines if it is the first comparison after
  ; the shift and adds the GOOD SUFFIX shift to the location counter.
  ; If the comparison is not the first after the shift, it calculates
  ; the GOOD SUFFIX shift and adds it to the location counter.
  ; -----------------------------------------------------------------

    LOCAL cval   :DWORD
    LOCAL shift_table[256]:DWORD

    push ebx
    push esi
    push edi

    mov ebx, subLngth

    cmp ebx, 1
    jg @F
    mov eax, -2                 ; string too short, must be > 1
    jmp Cleanup
  @@:

    mov esi, lpSource
    add esi, srcLngth
    sub esi, ebx
    mov edx, esi            ; set Exit Length

  ; ----------------------------------------
  ; load shift table with value in subLngth
  ; ----------------------------------------
    mov ecx, 256
    mov eax, ebx
    lea edi, shift_table
    rep stosd

  ; ----------------------------------------------
  ; load decending count values into shift table
  ; ----------------------------------------------
    mov ecx, ebx                ; SubString length in ECX
    dec ecx                     ; correct for zero based index
    mov esi, lpSubStr           ; address of SubString in ESI
    lea edi, shift_table

    xor eax, eax

  Write_Shift_Chars:
    mov al, [esi]               ; get the character
    inc esi
    mov [edi+eax*4], ecx        ; write shift for each character
    dec ecx                     ; to ascii location in table
    jnz Write_Shift_Chars

  ; -----------------------------
  ; set up for main compare loop
  ; -----------------------------
    mov ecx, ebx
    dec ecx
    mov cval, ecx

    mov esi, lpSource
    mov edi, lpSubStr
    add esi, startpos           ; add starting position

    jmp Pre_Loop

; %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Calc_Suffix_Shift:
    add eax, ecx
    sub eax, cval               ; sub loop count
    jns Add_Suffix_Shift
    mov eax, 1                  ; minimum shift is 1

  Add_Suffix_Shift:
    add esi, eax                ; add SUFFIX shift
    mov ecx, cval               ; reset counter in compare loop

  Test_Length:
    cmp edx, esi                ; test exit condition
    jl No_Match

  Pre_Loop:
    movzx eax, BYTE PTR [esi+ecx]
    cmp al, [edi+ecx]           ; cmp characters in ESI / EDI
    je @F
    mov eax, shift_table[eax*4]
    cmp ebx, eax
    jne Add_Suffix_Shift        ; bypass SUFFIX calculations
    add esi, ecx
    add esi, 1
    jmp Test_Length
  @@:
    sub ecx, 1

  Cmp_Loop:
    movzx eax, BYTE PTR [esi+ecx]
    cmp al, [edi+ecx]           ; cmp characters in ESI / EDI
    jne Set_Shift               ; if not equal, get next shift
    sub ecx, 1
    jns Cmp_Loop
    jmp Match                   ; fall through on match

  Set_Shift:
    mov eax, shift_table[eax*4]
    cmp ebx, eax
    jne Calc_Suffix_Shift       ; run SUFFIX calculations
    add esi, ecx
    add esi, 1
    jmp Test_Length

; %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Match:
    sub esi, lpSource           ; sub source from ESI
    mov eax, esi                ; put length in eax
    jmp Cleanup

  No_Match:
    mov eax, -1

  Cleanup:
    pop edi
    pop esi
    pop ebx

    ret

BM endp
RetBM:

end start
OPT_SUSY	CONSOLE
OPT_DelTmp	0
